#ifndef CREATURE_HH

#define CREATURE_HH

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//
// "Creature Box" -- flocking app
//
// by Christopher Rasmussen
//
// CISC 440/640, March, 2014
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include <vector>
#include <deque>
#include <string>

#include <sys/time.h>
#include <unistd.h>

#include <GL/glut.h>

#include "Utils.hh"

using namespace std;

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

class Creature
{
public:

  int index;

  Vec3 position;                       // current position
  Vec3 velocity;                       // current velocity
  Vec3 acceleration;                   // acceleration

  Vec3 new_position;                   // what position will be in next time step
  Vec3 new_velocity;                   // what velocity will be in next time step

  Vec3 up;                             // just like for gluLookAt()
  
  Vec3 frame_x;                        // local axes
  Vec3 frame_y;
  Vec3 frame_z;

  deque <Vec3> position_history;
  int max_history;
	
  Vec3 base_color;
  Vec3 draw_color;

  Creature(int,                    // index
	   double, double, double, // initial position
	   double, double, double, // initial velocity
	   float, float, float,    // base color
	   int = 1);               // number of past states to save

  virtual void draw() = 0;
  virtual void update() = 0;
  void finalize_update(double, double, double);

};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#endif
