//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//
// "Creature Box" -- flocking app
//
// by Christopher Rasmussen
//
// CISC 440/640, March, 2014
//
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

#include "Utils.hh";

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// MONO characters are all same width: 104.76 pixels

void draw_string(float x, float y, float char_width, char *text)
{
  char *p;
   
  glPushMatrix();
  glTranslatef(x, y, 0);
  glScalef(char_width / 104.76, char_width / 104.76, 1);
  for (p = text; *p; p++)
    glutStrokeCharacter(GLUT_STROKE_MONO_ROMAN, *p);
  // proportional: looks better, but characters are different widths
  //    glutStrokeCharacter(GLUT_STROKE_ROMAN, *p);
  glPopMatrix();
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

// set seed based on time so no two runs are alike

void initialize_random()
{
  struct timeval tp;

  gettimeofday(&tp, NULL);
  srand48(tp.tv_sec);
}

//----------------------------------------------------------------------------

// random float in range [lower, upper]

double uniform_random(double lower, double upper)
{
  double result;
  double range_size;

  range_size = upper - lower;
  result = range_size * drand48();
  result += lower;

  return result;
}

//----------------------------------------------------------------------------

// random int in range [lower, upper]

int uniform_random_int(int lower, int upper)
{
  return (int) round(uniform_random(lower, upper));
}

//----------------------------------------------------------------------------

// in seconds

double get_timestamp()
{
  struct timeval tv;

  gettimeofday(&tv, NULL);

  return (double) tv.tv_sec + 0.000001 * (double) tv.tv_usec;
}

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
